﻿using Encompass.Collections;
using FluentAssertions;
using NUnit.Framework;

namespace Tests
{
    public class BitSet1024Test
    {
        [Test]
        public void Zeroes()
        {
            var bitSet = BitSet1024Builder.Zeroes();
            bitSet.AllFalse().Should().BeTrue();
        }

        [Test]
        public void Ones()
        {
            var bitSet = BitSet1024Builder.Ones();
            bitSet.AllTrue().Should().BeTrue();
        }

        [Test]
        public void Set()
        {
            var bitSet = BitSet1024Builder.Zeroes().Set(5);
            bitSet.AllFalse().Should().BeFalse();

            bitSet = BitSet1024Builder.Zeroes().Set(278);
            bitSet.AllFalse().Should().BeFalse();

            bitSet = BitSet1024Builder.Zeroes().Set(569);
            bitSet.AllFalse().Should().BeFalse();

            bitSet = BitSet1024Builder.Zeroes().Set(1023);
            bitSet.AllFalse().Should().BeFalse();
        }

        [Test]
        public void UnSet()
        {
            var bitSet = BitSet1024Builder.Ones().UnSet(562);
            bitSet.Get(562).Should().BeFalse();
            bitSet.Set(562).AllTrue().Should().BeTrue();
        }

        [Test]
        public void Get()
        {
            var bitSet = BitSet1024Builder.Zeroes().Set(359);
            bitSet.Get(359).Should().BeTrue();
            bitSet.UnSet(359).AllFalse().Should().BeTrue();
        }

        [Test]
        public void Not()
        {
            var bitSet = BitSet1024Builder.Ones().Not();
            bitSet.AllFalse().Should().BeTrue();
        }
    }
}
